<template>
  <div class="bd-1 bd-rds-xs bg-grey-2">
    <div class="menu-bar-editor bg-grey-3">
      <editor-menu-bar
        v-slot="{ commands, isActive, getMarkAttrs }"
        :editor="editor"
        @hide="hideLinkMenu"
      >
        <div class="menubar d-flex items-center">
          <a
            class="p-2x clickable"
            :class="{ active: isActive.bold() }"
            @click.prevent="commands.bold"
          >
            <b-icon name="te-bold" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ active: isActive.italic() }"
            @click.prevent="commands.italic"
          >
            <b-icon name="te-italic" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ active: isActive.strike() }"
            @click.prevent="commands.strike"
          >
            <b-icon name="te-strike" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ active: isActive.underline() }"
            @click.prevent="commands.underline"
          >
            <b-icon name="te-underline" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ active: isActive.code() }"
            @click.prevent="commands.code"
          >
            <b-icon name="te-code" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ active: isActive.paragraph() }"
            @click.prevent="commands.paragraph"
          >
            <b-icon name="te-paragraph" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ 'is-active': isActive.heading({ level: 1 }) }"
            @click.prevent="commands.heading({ level: 1 })"
          >
            <b-icon name="te-h1" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ 'is-active': isActive.heading({ level: 2 }) }"
            @click.prevent="commands.heading({ level: 2 })"
          >
            <b-icon name="te-h2" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ 'is-active': isActive.heading({ level: 3 }) }"
            @click.prevent="commands.heading({ level: 3 })"
          >
            <b-icon name="te-h3" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ 'is-active': isActive.bullet_list() }"
            @click.prevent="commands.bullet_list"
          >
            <b-icon name="task-list" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ 'is-active': isActive.ordered_list() }"
            @click.prevent="commands.ordered_list"
          >
            <b-icon name="te-list-ol" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ 'is-active': isActive.blockquote() }"
            @click.prevent="commands.blockquote"
          >
            <b-icon name="te-quote" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            :class="{ 'is-active': isActive.code_block() }"
            @click.prevent="commands.horizontal_rule"
          >
            <i class="el-icon-minus c-black" width="16" />
          </a>
          <a class="p-2x clickable" @click.prevent="commands.undo">
            <b-icon name="te-undo" :size="16" class="c-black" />
          </a>
          <a class="p-2x clickable" @click.prevent="commands.redo">
            <b-icon name="te-redo" :size="16" class="c-black" />
          </a>
          <a v-if="linkMenuIsActive" class="p-2x">
            <form
              v-if="linkMenuIsActive"
              class="d-flex items-center"
              @submit.prevent="setLinkUrl(commands.link, linkUrl)"
            >
              <b-input
                ref="linkInput"
                v-model="linkUrl"
                type="text"
                placeholder="https://"
                @keydown.esc="hideLinkMenu"
              />
              <b-button-icon
                name="delete"
                class="ml-2x"
                @click="setLinkUrl(commands.link, null)"
              >
              </b-button-icon>
            </form>
          </a>
          <a
            v-else
            class="p-2x clickable"
            @click.prevent="showLinkMenu(getMarkAttrs('link'))"
          >
            <b-icon name="link" :size="16" class="c-black" />
          </a>
          <a
            class="p-2x clickable"
            @click.prevent="showImagePrompt(commands.image)"
          >
            <b-icon name="image-multiple" :size="16" class="c-black" />
          </a>

          <a
            v-if="withLawSummary"
            class="p-2x clickable"
            @click.prevent="onLinkLawSummary()"
          >
            <b-icon name="document" :size="16" class="c-black" />
          </a>
          <a
            v-if="withField"
            class="p-2x clickable"
            @click.prevent="onInsertField()"
          >
            <b-icon name="task-list" :size="16" class="c-black" />
          </a>

          <div v-if="resize" style="flex: auto">
            <a
              title="+ height"
              class="p-2x"
              :class="
                config.height !== config.maxHeight ? 'clickable' : 'c-disable'
              "
              style="float: right"
              @click.prevent="handleHeightPlus"
            >
              <b-icon name="control-plus" :size="16" class="c-black" />
            </a>
            <a
              title="- height"
              class="p-2x"
              :class="
                config.height !== config.minHeight ? 'clickable' : 'c-disable'
              "
              style="float: right"
              @click.prevent="handleHeightMinus"
            >
              <b-icon name="control-minus" :size="16" class="c-black" />
            </a>
          </div>
        </div>
      </editor-menu-bar>
    </div>
    <editor-content
      :editor="editor"
      class="editor-content__container ov-y-auto"
      :style="'height:' + config.height + 'px'"
    />
  </div>
</template>

<script>
import { Editor, EditorContent, EditorMenuBar } from 'tiptap'
import {
  Blockquote,
  CodeBlock,
  HardBreak,
  Heading,
  OrderedList,
  BulletList,
  ListItem,
  TodoItem,
  TodoList,
  Bold,
  Code,
  Italic,
  Link,
  Strike,
  Underline,
  Image,
  History,
  HorizontalRule,
} from 'tiptap-extensions'
import { cloneDeep } from 'lodash'

export default {
  name: 'TextEditor',
  components: {
    EditorMenuBar,
    EditorContent,
  },
  props: {
    value: {
      type: String,
      default() {
        return ''
      },
    },
    height: {
      type: Number,
      default() {
        return 287
      },
    },
    resize: {
      type: Boolean,
      default() {
        return false
      },
    },
    withLawSummary: {
      type: Boolean,
      default() {
        return false
      },
    },
    withField: {
      type: Boolean,
      default() {
        return false
      },
    },
  },
  data() {
    return {
      editor: new Editor({
        extensions: [
          new Blockquote(),
          new CodeBlock(),
          new HardBreak(),
          new Heading({ levels: [1, 2, 3] }),
          new BulletList(),
          new OrderedList(),
          new ListItem(),
          new TodoItem(),
          new TodoList(),
          new Bold(),
          new Code(),
          new Italic(),
          new Link(),
          new Strike(),
          new Underline(),
          new Image(),
          new History(),
          new HorizontalRule(),
        ],
        content: cloneDeep(this.value),
        onUpdate: (context) => {
          const htmlContent = context.getHTML() || ''
          const emptyContent = htmlContent
            ?.replaceAll(' ', '')
            .replaceAll('\n', '')

          if (emptyContent === '<p></p>') this.$emit('input', '')
          else this.$emit('input', htmlContent)
        },
      }),
      linkUrl: null,
      linkMenuIsActive: false,

      config: {
        height: this.height,
        minHeight: 100,
        maxHeight: 400,
      },
    }
  },
  // watch: {
  //   value(val, old) {
  //     if (val !== old) this.editor.setContent(val)
  //   },
  // },
  beforeDestroy() {
    this.editor.destroy()
  },
  methods: {
    async handleHeightPlus() {
      for (let i = 0; i < 100; i++) {
        this.config.height += 1
        if (this.config.height > this.config.maxHeight) {
          this.config.height = this.config.maxHeight
          break
        }
        await this.sleep(3)
      }
    },
    async handleHeightMinus() {
      for (let i = 0; i < 100; i++) {
        this.config.height -= 1
        if (this.config.height < this.config.minHeight) {
          this.config.height = this.config.minHeight
          break
        }
        await this.sleep(3)
      }
    },
    sleep(ms) {
      return new Promise((resolve) => setTimeout(resolve, ms))
    },

    showImagePrompt(command) {
      const src = prompt('Enter the url of your image here')
      if (src !== null) {
        command({ src })
      }
    },

    showLinkMenu(attrs) {
      if (this.editor.selection.from === this.editor.selection.to) {
        this.$message.error('Please select text!')
        return
      }

      this.linkUrl = attrs.href
      this.linkMenuIsActive = true
      this.$nextTick(() => {
        this.$refs.linkInput.focus()
      })
    },
    hideLinkMenu() {
      this.linkUrl = null
      this.linkMenuIsActive = false
    },
    setLinkUrl(command, url) {
      command({ href: url })
      this.hideLinkMenu()
    },

    onLinkLawSummary() {
      if (this.editor.selection.from === this.editor.selection.to) {
        this.$message.error('Please select text!')
        return
      }

      this.$emit('onLinkLawSummary', (lawSummary) => {
        this.editor.commands.link({
          href: `javascript:void('${lawSummary.id}', '${lawSummary.sectionId}')`,
        })
      })
    },

    onInsertField() {
      this.$emit('insertField', (field) => {
        this.demoEditorInsertText(`{{ ${field} }}`)
      })
    },
    demoEditorInsertText(text) {
      const transaction = this.editor.state.tr.insertText(text)
      this.editor.view.dispatch(transaction)
    },
  },
}
</script>

<style lang="scss">
@import '@bigin/bigin-ui-ds/src/scss/settings';
.editor-content__container {
  blockquote {
    border-left: 3px solid $color-grey-5;
    font-style: italic;

    p {
      margin-left: 0.5rem;
    }
  }

  ul,
  ol {
    margin-left: 2rem;
  }

  ul {
    list-style: circle;
  }

  ol {
    list-style: decimal;
  }

  .ProseMirror {
    min-height: 100%;
    padding: 16px;
    background-color: #f5f5f5;
    border-radius: 0 0 4px 4px;
  }

  .ProseMirror-focused {
    background-color: #ffffff;
  }
}
.c-disable {
  opacity: 0.35;
}
</style>
